<?php
require("../LdapManager.php");
require("../LdapConf.php");
require("../xml2Array.php");

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

$success=false;
header('Content-type: text/xml');
echo "<?xml version='1.0' encoding='UTF-8' ?>\n";
echo "<LDIF_import>\n";
$success=true;
if (isset($_POST['format'])&&strcmp($_POST['format'],"ldif")==0) {
    if (isset($_POST['data'])) {
        $ldif=base64_decode($_POST['data']);
    }
    $dn='';
    $objClass=array();
    $attributes=array();
    $tok=strtok($ldif,"\n");
    while ($tok!==false) {
    	$tok=substr($tok,0,strlen($tok)-1);
        if (strcmp($tok,"")==0&&strcmp($dn,"")!=0) { // Add the entry
            echo "<ImportInfo dn='".$dn."'>\n";
            if ($lm->addEntry($dn,$objClass,$attributes)) {
                echo "<Status status='success'/>";
            }
            else {
                echo "<Status status='fail' message='".$lm->getErrorMessage()."'/>";
            }
            echo "</ImportInfo>\n";
        }
        $labelRaw=substr($tok,0,strpos($tok,' '));
        if (strpos($labelRaw,"::")===false) {
        	$label=substr($labelRaw,0,strlen($labelRaw)-1);
	        $value=substr($tok,strpos($tok,' ')+1);
        }
        else {
        	$label=substr($labelRaw,0,strlen($labelRaw)-2);
	        $value=base64_decode(substr($tok,strpos($tok,' ')+1));
        }
        if (strcmp($label,"dn")==0) {
            // Init a new entry
            $dn=$value;
            $objClass=array();
            $attributes=array();
        }
        else if (strcmp($label,"objectClass")==0) {
            $objClass[]=$value;
        }
        else if (strcmp($label,"")!=0) {
            if (!array_key_exists($label,$attributes)) {
                $attributes[$label]=array();
            }
            $attributes[$label][]=$value;
        }
        $tok=strtok("\n");
    }
}
echo "</LDIF_import>";
/*if ($success==true) {
    echo "<OperationInfo><Status status='success'/></OperationInfo>";
}
else {
    echo "<OperationInfo><Status status='fail'/><ErrorMessage message='".$lm->getErrorMessage()."'/></OperationInfo>"; 
} */

?>
